"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getDetector;

var _lodash = _interopRequireDefault(require("lodash.isregexp"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hasOwn = function hasOwn(obj, key) {
  return Object.prototype.hasOwnProperty.call(obj, key);
};

function getDetector(_ref) {
  var exclude = _ref.exclude;

  var detector = function detector(text) {
    return /[\u4e00-\u9fa5]/.test(text);
  };

  var cache = {};
  return function (text, filename) {
    if (exclude && filename) {
      if ((0, _lodash.default)(exclude) && exclude.test(filename)) {
        return false;
      }

      if (Array.isArray(exclude) && exclude.some(function (regExp) {
        return regExp.test(filename);
      })) {
        return false;
      }
    }

    if (text === '__proto__') {
      // __proto__ property could not be set, it's value of 'cache' is always {}
      return false;
    }

    if (!hasOwn(cache, text)) {
      cache[text] = !!detector(text);
    }

    return cache[text];
  };
}

module.exports = exports["default"];